## org.jfree.ui
Class SerialDateChooserPanel

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      org.jfree.ui.SerialDateChooserPanel

All Implemented Interfaces:
  javax.accessibility.Accessible, java.awt.event.ActionListener, java.util.EventListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable

public class SerialDateChooserPanel
extends javax.swing.JPanel
implements java.awt.event.ActionListener

A panel that allows the user to select a date.

This class is incomplete and untested. You should not use it yet...

Author:
  David Gilbert
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class javax.swing.JPanel
`javax.swing.JPanel.AccessibleJPanel`

Nested classes inherited from class javax.swing.JComponent
`javax.swing.JComponent.AccessibleJComponent`

Nested classes inherited from class java.awt.Container
`java.awt.Container.AccessibleAWTContainer`

Nested classes inherited from class java.awt.Component
`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

Field Summary
`static java.awt.Color` `DEFAULT_DATE_BUTTON_COLOR` The default background color for the selected date.
`static java.awt.Color` `DEFAULT_MONTH_BUTTON_COLOR` The default background color for the current month.

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`SerialDateChooserPanel()` Constructs a new date chooser panel, using today's date as the initial selection.
`SerialDateChooserPanel(SerialDate date, boolean controlPanel)` Constructs a new date chooser panel.
`SerialDateChooserPanel(SerialDate date, boolean controlPanel, java.awt.Color dateButtonColor, java.awt.Color monthButtonColor)` Constructs a new date chooser panel.

Method Summary
`void` `actionPerformed(java.awt.event.ActionEvent e)` Handles action-events from the date panel.
`protected java.awt.Color` `getButtonColor(SerialDate targetDate)` Returns the button color according to the specified date.
`SerialDate` `getDate()` Returns the date selected in the panel.
`protected SerialDate` `getFirstVisibleDate()` Returns the first date that is visible in the grid.
`protected void` `refreshButtons()` Update the button labels and colors to reflect date selection.
`void` `setDate(SerialDate date)` Sets the date chosen in the panel.

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DEFAULT_DATE_BUTTON_COLOR

    public static final java.awt.Color DEFAULT_DATE_BUTTON_COLOR

  The default background color for the selected date.

### DEFAULT_MONTH_BUTTON_COLOR

    public static final java.awt.Color DEFAULT_MONTH_BUTTON_COLOR

  The default background color for the current month.

Constructor Detail

### SerialDateChooserPanel

    public SerialDateChooserPanel()

  Constructs a new date chooser panel, using today's date as the initial selection.

### SerialDateChooserPanel

    public SerialDateChooserPanel(SerialDate date,
                                  boolean controlPanel)

  Constructs a new date chooser panel.

Parameters:
  `date` - the date.
  `controlPanel` - a flag that indicates whether or not the 'today' button should appear on the panel.

### SerialDateChooserPanel

    public SerialDateChooserPanel(SerialDate date,
                                  boolean controlPanel,
                                  java.awt.Color dateButtonColor,
                                  java.awt.Color monthButtonColor)

  Constructs a new date chooser panel.

Parameters:
  `date` - the date.
  `controlPanel` - the control panel.
  `dateButtonColor` - the date button color.
  `monthButtonColor` - the month button color.

Method Detail

### setDate

    public void setDate(SerialDate date)

  Sets the date chosen in the panel.

  Parameters:
    `date` - the new date.

### getDate

    public SerialDate getDate()

  Returns the date selected in the panel.

  Returns:
    the selected date.

### actionPerformed

    public void actionPerformed(java.awt.event.ActionEvent e)

  Handles action-events from the date panel.

  Specified by:
    `actionPerformed` in interface `java.awt.event.ActionListener`
  Parameters:
    `e` - information about the event that occurred.

### getButtonColor

    protected java.awt.Color getButtonColor(SerialDate targetDate)

  Returns the button color according to the specified date.

  Parameters:
    `targetDate` - the target date.
  Returns:
    the button color.

### getFirstVisibleDate

    protected SerialDate getFirstVisibleDate()

  Returns the first date that is visible in the grid. This should always be in the month preceding the month of the selected date.

  Returns:
    the first visible date.

### refreshButtons

    protected void refreshButtons()

  Update the button labels and colors to reflect date selection.